#! python
"""
script: aprbootstrap
Author: Ernesto Posse
Created on: July 31, 2006
Last update: July 31, 2006

Description:
    This script is used to generate the parser for the metacfg, this is, the parser for .apr files, and bootstrap it.
    The user of the package does not normally need to use this script. Use this script only if you want to change the syntax of the .cfg files, and at your own risk.
"""

import sys
import os.path
sys.path += ['..']
import aperiot
pkg_name = os.path.abspath(aperiot.__path__[0])
sys.path += [pkg_name]
from aperiot.parsergen import *

dir = os.path.abspath(aperiot.__path__[0])

print "Building base metacfg"

cfg_description_module = 'metacfg_wat'
parser1 = build_parser(cfg_description_module, verbose=True)
save_parser(parser1, dir, cfg_description_module, verbose=True)

print "Building bootstrapped metacfg"

cfg_description_module = 'metacfg_bootstrap'
parser2 = build_parser(cfg_description_module, verbose=True)
save_parser(parser2, dir, cfg_description_module, verbose=True)

print "Setup completed"


