# First, make sure the aperiot package is in sys.path 
# I use path_setup for this purpose.

import os.path
import sys
sys.path.append(os.path.abspath('../src'))

import posse_tools.path_setup
posse_tools.path_setup.setup_paths(required_modules=['parser'], strict=False, verbosity=0)

# Second, import the parser module.

from aperiot.parser import build_parser

# Third, give the name of the module containing the CFG's python description

cfg_description_module = 'akalo_wat'

# Fourth, create the parser.

parser = build_parser(cfg_description_module, 
                        modules_to_import=['astlista'],
                        newline_sensitive=False, 
                        indent_sensitive=False,
                        save_generated_modules=False)

# Fifth, provide the source text to be parsed. It can be a string or a file, or any other iterator over characters.

text = '56 43 21'

# Finally, parse the text. 

# Use either:

#~ outcome = parser.parse(text)

# ... to apply the actions to the parse tree and obtain the final result,

# or

tree = parser.parse(text, apply_actions=False)
outcome = parser.apply_actions(tree)

# ... to obtain the parse tree and separately apply the actions.

print str(tree)
print outcome
