"""
Module: stacks
Author: Ernesto Posse
Created on: April 12, 2006
Last modified: April 18, 2006

Description:
    Implements a basic stack class
"""

class EmptyStack(Exception):
    pass

class Stack:
    
    def __init__(self, elements = []):
        self.stack = []
        self.top_index =  - 1
        for item in reversed(elements):
            self.push(item)
    
    def push(self, item):
        #~ print "push ",item,self.top_index,self.stack
        self.stack.append(item)
        self.top_index += 1
    
    def pop(self):
        #~ print "pop",self.top_index,self.stack
        if self.top_index < 0:
            raise EmptyStack()
        self.top_index -= 1
        return self.stack.pop()
    
    def top(self):
        #~ print "top",self.top_index,self.stack
        #~ print str(self)
        if self.top_index < 0:
            raise EmptyStack()
        return self.stack[self.top_index]
    
    def isempty(self):
        return self.top_index < 0
    
    def __iter__(self):
        self.iter_index = self.top_index
        return self
    
    def next(self):
        if self.iter_index < 0:
            raise StopIteration
        answer = self.stack[self.iter_index]
        self.iter_index -= 1
        return answer

    def __str__(self):
        return str([str(self.stack[i]) for i in range(self.top_index, -1, -1)])
        
    
    
        
        
